/* ======================================================================= */
/* mathlib.h --  Interface header file                 */
/*                                                                         */
/* Rev 0.0.1                                                               */
/*                                                                         */
/* Copyright (C) 2011 Texas Instruments Incorporated - http://www.ti.com/  */
/*                                                                         */
/*                                                                         */
/*  Redistribution and use in source and binary forms, with or without     */
/*  modification, are permitted provided that the following conditions     */
/*  are met:                                                               */
/*                                                                         */
/*    Redistributions of source code must retain the above copyright       */
/*    notice, this list of conditions and the following disclaimer.        */
/*                                                                         */
/*    Redistributions in binary form must reproduce the above copyright    */
/*    notice, this list of conditions and the following disclaimer in the  */
/*    documentation and/or other materials provided with the               */
/*    distribution.                                                        */
/*                                                                         */
/*    Neither the name of Texas Instruments Incorporated nor the names of  */
/*    its contributors may be used to endorse or promote products derived  */
/*    from this software without specific prior written permission.        */
/*                                                                         */
/*  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS    */
/*  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT      */
/*  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR  */
/*  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT   */
/*  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,  */
/*  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT       */
/*  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,  */
/*  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY  */
/*  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT    */
/*  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE  */
/*  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.   */
/*                                                                         */
/* ======================================================================= */
#include <ti/mathlib/src/acosdp/acosdp.h>
#include <ti/mathlib/src/acoshdp/acoshdp.h>
#include <ti/mathlib/src/acoshsp/acoshsp.h>
#include <ti/mathlib/src/acossp/acossp.h>
#include <ti/mathlib/src/asindp/asindp.h>
#include <ti/mathlib/src/asinhdp/asinhdp.h>
#include <ti/mathlib/src/asinhsp/asinhsp.h>
#include <ti/mathlib/src/asinsp/asinsp.h>
#include <ti/mathlib/src/atan2dp/atan2dp.h>
#include <ti/mathlib/src/atan2sp/atan2sp.h>
#include <ti/mathlib/src/atandp/atandp.h>
#include <ti/mathlib/src/atanhdp/atanhdp.h>
#include <ti/mathlib/src/atanhsp/atanhsp.h>
#include <ti/mathlib/src/atansp/atansp.h>
#include <ti/mathlib/src/cosdp/cosdp.h>
#include <ti/mathlib/src/coshdp/coshdp.h>
#include <ti/mathlib/src/coshsp/coshsp.h>
#include <ti/mathlib/src/cossp/cossp.h>
#include <ti/mathlib/src/divdp/divdp.h>
#include <ti/mathlib/src/divsp/divsp.h>
#include <ti/mathlib/src/exp10dp/exp10dp.h>
#include <ti/mathlib/src/exp10sp/exp10sp.h>
#include <ti/mathlib/src/exp2dp/exp2dp.h>
#include <ti/mathlib/src/exp2sp/exp2sp.h>
#include <ti/mathlib/src/expdp/expdp.h>
#include <ti/mathlib/src/expsp/expsp.h>
#include <ti/mathlib/src/log10dp/log10dp.h>
#include <ti/mathlib/src/log10sp/log10sp.h>
#include <ti/mathlib/src/log2dp/log2dp.h>
#include <ti/mathlib/src/log2sp/log2sp.h>
#include <ti/mathlib/src/logdp/logdp.h>
#include <ti/mathlib/src/logsp/logsp.h>
#include <ti/mathlib/src/powdp/powdp.h>
#include <ti/mathlib/src/powsp/powsp.h>
#include <ti/mathlib/src/recipdp/recipdp.h>
#include <ti/mathlib/src/recipsp/recipsp.h>
#include <ti/mathlib/src/rsqrtdp/rsqrtdp.h>
#include <ti/mathlib/src/rsqrtsp/rsqrtsp.h>
#include <ti/mathlib/src/sindp/sindp.h>
#include <ti/mathlib/src/sinhdp/sinhdp.h>
#include <ti/mathlib/src/sinhsp/sinhsp.h>
#include <ti/mathlib/src/sinsp/sinsp.h>
#include <ti/mathlib/src/sqrtdp/sqrtdp.h>
#include <ti/mathlib/src/sqrtsp/sqrtsp.h>
#include <ti/mathlib/src/tandp/tandp.h>
#include <ti/mathlib/src/tanhdp/tanhdp.h>
#include <ti/mathlib/src/tanhsp/tanhsp.h>
#include <ti/mathlib/src/tansp/tansp.h>
